<?php
/**
 * @package Sj Vm Listing
 * @version 2.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;

class VmListingReader extends SjReader{
	protected $_categories = null;

	public function getList(&$params){
		//YTools::dump($params);
		$user	= &JFactory::getUser();
		$app	= &JFactory::getApplication();
		$db		= &JFactory::getDBO();
			
		// category filter
		$all_category_flag = false;
		if (!isset($params['source']) || $params['source']==''){
			// all categories
			$all_category_flag = true;
		} else if (!is_array($params['source'])){
			if ((int)$params['source']){
				$params['source'] = array($params['source']);
			} else {
				$all_category_flag = true;
			}
		}
			
		$categories = array();
		if ($all_category_flag){
			$categories = $this->_getCategories();
		} else {
			$categories = $this->getCategoryById($params['source']);
		}
		foreach ($categories as $key=> $category){
			//$category->child = array();
			$categories[$category->id]->child=$this->itemsForCategory($key,$params);
				
		}
		/* Ytools::dump($categories); */
		return $categories;
	}

	public function _getCategories(){
		if (is_null($this->_categories)){
			$db = &JFactory::getDBO();
			$query = "
					SELECT
						c.virtuemart_category_id AS id,
						engb.category_name AS title,
						engb.slug AS slug,
						cx.category_parent_id AS parent
					FROM #__virtuemart_categories_en_gb AS engb
						JOIN #__virtuemart_categories AS c USING (virtuemart_category_id)
						LEFT JOIN #__virtuemart_category_categories AS cx ON cx.category_child_id=engb.virtuemart_category_id
					WHERE c.published=1
					ORDER BY c.ordering
				";
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			$list = array();
			if (count($rows)>0){
				// mark by category id
				foreach ($rows as $i => $cat) {
					$cat->level = 1;
					$list[$cat->id] = &$rows[$i];
					//YTools::dump($cat, "$i:");
				}
				// build child list for parent category.
				foreach ($list as $cid => $category) {
					if (isset($list[$category->parent])){
						$parent_category = &$list[$category->parent];
						if (!isset($parent_category->child_category)){
							$parent_category->child_category = array();
						}
						$parent_category->child_category[$cid] = &$list[$cid];
					}
					$category->cat_link=JRoute::_('index.php?option=com_virtuemart&view=category&virtuemart_category_id='.$category->id);
				}
			}
			$this->_categories = $list;
		}
		return $this->_categories;
	}

	public function getCategoryById($cid=array()){
		$categories = &$this->_getCategories();
		if (!is_array($cid)){
			if (isset($categories[$cid])){
				$category = &$categories[$cid];
			} else {
				$category = null;
			}
			return $category;
		} else if (count($cid) > 0){
			$category = array();
			foreach ($cid as $id){
				if (isset($categories[$id])){
					$category[$id] = &$categories[$id];
				}
			}
			return $category;
		}
		return $categories;
	}

	public function getChildOf($ids=array(), $self_included=false, $deep=0){
		$return = array();
		if (!is_array($ids)){
			$ids = array($ids);
		}
		$categories = &$this->_getCategories();
		foreach ($ids as $cid) {
			if (isset($categories[$cid])){
				if ($deep>0){
					$categories[$cid]->level = 1;
				}
				$stack = array($categories[$cid]);
				while( count($stack)>0 ){
					$top = array_pop($stack);
					if ($self_included || $cid != $top->id){
						in_array($top->id, $return) || array_push($return, $top->id);
					}
					if (isset($top->child_category)){
						foreach (array_reverse($top->child_category) as $child){
							if ($deep>0 && ($top->level+1>$deep)){
								continue;
							} else if ($deep>0) {
								$child->level = $top->level + 1;
							}
							array_push($stack, $child);
						}
					}
				}
			}
		}

		return $return;
	}

	private function _getRootParentOf($category_id, $category_map){
		$return = array();
		foreach ($category_map as $rid => $cids) {
			if (in_array($category_id, $cids)){
				array_push($return, $rid);
			}
		}
		return count($return);
	}
	public function itemsForCategory($category_id, $params){
		$child_category_ids = array();
		if (isset($params['subcategories']) && (int)$params['subcategories']){
			// $include_subcategories = true;
			$child_category_ids = $this->getChildOf($category_id, true);
			//die();
		} else {
			// $include_subcategories = false;
			$child_category_ids = array($category_id);
		}
		return $this->getCategoryItems($child_category_ids, $params);
	}

	public function getCategoryItems($category_ids, $params){
		$user	= &JFactory::getUser();
		$app	= &JFactory::getApplication();
		$db		= &JFactory::getDBO();
		$arrcustom_url=array();
		$arrcustom_url = $this->_getCustomData($params['custom_url']);
		$category_filter = "AND pcx.virtuemart_category_id IN (" . implode(',', $category_ids) . ")";;
			
		// special filter
		$source_filter = "";
		if (isset($params['source_filter']) && (int)$params['source_filter']){
			switch((int)$params['source_filter']){
				case 1:
					$source_filter = "AND p2.product_special=0";
					break;
				case 2:
					$source_filter = "AND p2.product_special=1";
					break;
			}
		}

		// source order by
		$source_order_by = "";
		if (isset($params['source_order_by'])){
			switch ($params['source_order_by']){
				default:
				case 'ordering':
					$source_order_by = "ORDER BY p2.product_sku";
				break;
				case 'bestsales':
					$source_order_by = "ORDER BY p2.product_sales DESC";
					break;
				case 'reviews':
					$source_order_by = "ORDER BY reviews DESC";
					break;
				case 'pricedes':
					$source_order_by = "ORDER BY price.product_price DESC";
					break;
				case 'priceasc':
					$source_order_by = "ORDER BY price.product_price";
					break;
				case 'created':
					$source_order_by = "ORDER BY p2.created_on DESC";
					break;
				case 'modified':
					$source_order_by = "ORDER BY p2.modified_on DESC";
					break;
				case 'title':
					$source_order_by = "ORDER BY p1.product_name";
					break;
				case 'random':
					$source_order_by = "ORDER BY rand()";
					break;
			}
		}

		// source limit ?
		$source_limit = "";
		if (isset($params['source_limit']) && (int)$params['source_limit']){
			$source_limit_start = 0;
			if (isset($params['source_limit_start']) && (int)$params['source_limit_start']){
				$source_limit_start = (int)$params['source_limit_start'];
			}
			$source_limit_total = (int)$params['source_limit'];
			$source_limit = "LIMIT $source_limit_start, $source_limit_total";
		} else {
			$source_limit = "LIMIT 0, 5";
		}
			
		$query = "
							SELECT
								p1.virtuemart_product_id AS id,
								p1.product_name AS title,
								p1.product_s_desc AS description,
								p1.slug AS slug,
								p2.product_sku AS sku,
								p2.product_in_stock,							
								p2.product_ordered,								
								p2.product_sales,
								p2.created_on AS created,
								price.virtuemart_product_price_id,
								(
									SELECT m.file_url
									FROM #__virtuemart_medias m
									INNER JOIN #__virtuemart_product_medias pm ON pm.virtuemart_media_id=m.virtuemart_media_id
									WHERE pm.virtuemart_product_id=p2.virtuemart_product_id AND m.published=1
									ORDER BY pm.ordering
									LIMIT 0, 1
								) AS image,
								(SELECT COUNT(pr.virtuemart_rating_review_id) FROM #__virtuemart_rating_reviews pr WHERE pr.virtuemart_product_id=p2.virtuemart_product_id AND pr.published=1) AS reviews,
								GROUP_CONCAT(pcx.virtuemart_category_id) AS categories
							FROM #__virtuemart_products_en_gb AS p1
								JOIN #__virtuemart_products AS p2 USING (virtuemart_product_id)
								LEFT JOIN #__virtuemart_product_prices AS price ON price.virtuemart_product_id=p1.virtuemart_product_id
								JOIN #__virtuemart_product_categories AS pcx ON pcx.virtuemart_product_id=p1.virtuemart_product_id
						  	WHERE
						  		p2.published=1
		$category_filter
		$source_filter
						  	GROUP BY p2.virtuemart_product_id
		$source_order_by
		$source_limit
						";
		// YTools::dump(str_replace('#__', 'jos_', $query));
		$db->setQuery($query);
		$rows = $db->loadObjectList();

		// return data
		class_exists( 'VmConfig' ) or require JPATH_ADMINISTRATOR .DS. 'components' .DS. 'com_virtuemart' .DS. 'helpers' .DS. 'config.php';
		VmConfig::loadConfig();
		class_exists('calculationHelper') or require JPATH_VM_ADMINISTRATOR .DS. 'helpers' .DS. 'calculationh.php';
		class_exists( 'CurrencyDisplay' ) or require JPATH_VM_ADMINISTRATOR .DS. 'helpers' .DS. 'currencydisplay.php';
		$calculator = calculationHelper::getInstance();
		$list = array();
		if (count($rows)){
			foreach($rows as $product){
				$temp=array();
				$virtuemart_category_id = (int)$product->categories;
				$product->categories = explode(',', $product->categories);
				// assign to category.
				foreach ($product->categories  as $category_id) {
					if ( $this->getCategoryById($category_id) ){
						$_category = &$this->getCategoryById($category_id);
						if (!isset($_category->child)){
							$_category->child = array();
						}
						$_category->child[$product->id] = $product;
					}
				}
					
				$product->prices = $calculator->getProductPrices($product->id);

					
				if(array_key_exists($product->id, $arrcustom_url)){
					$product->link = $arrcustom_url[$product->id];
				} else {
					$product_url = "index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id={$product->id}&virtuemart_category_id={$virtuemart_category_id}";
					$product->link = JRoute::_($product_url);
				}

				//$product->createdfrom = JHTML::_('date', $product->created, JText::_('DATE_FORMAT_LC3'));
				if (is_null($product->image) || !file_exists($product->image)){
					$product->image = 'modules/' . YTools::getModule()->module . '/assets/images/nophoto.gif';
				}
				$product->desc=$product->description;
				if ($params['item_description_keephtml'] == 0){
					$product->desc = strip_tags($product->desc);
				}
				$temp['id']=$product->id;
				$temp['title']=$product->title;
				$temp['link']=$product->link;
				$temp['image']=$product->image;
				$temp['desc']=$product->desc;
				$temp['reviews']=$product->reviews;
				$temp['created']=$product->created;
				$temp['prices']=$product->prices	;
				$list[] = $temp;
			}
		}
			
		// render or ?
		//	Ytools::dump($list);
		return $list;
	}
	private function _getCustomData($custom_url) {
		$arrUrl = array();
		$tmp = explode("\n", trim($custom_url));
		foreach( $tmp as $strTmp){
			$pos = strpos($strTmp, ":");
			if($pos >=0){
				$tmpKey = substr($strTmp, 0, $pos);
				$key = trim($tmpKey);
				$tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);
				$haveHttp =  strpos(trim($tmpLink), "http://");
				if($haveHttp<0 || ($haveHttp !== false) ){
					$link = trim($tmpLink);
				}else{
					$link = "http://" . trim($tmpLink);
				}
				$arrUrl[$key] = $link;
			}
		}
		return $arrUrl;
	}
}
